# Copyright 2017 Jose Nelson Amaral
# Copyright 2017 Erick Ochoa Lopez
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
# 
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import random

def uniform(default):
	'''
	returns: default +- (default + 1) / 2
	'''
	limit = abs(default / 2)
	offset = random.uniform(-limit, limit)
	return default + offset

def randint(default):
	'''
	returns: default +- (default + 1) / 2
	'''
	return int(uniform(default))

def forceRetVal(function, *args, **kwargs):
	def wrapper(*args, **kwargs):
		retVal = kwargs.get('retVal')
		if retVal is None:
			return function(*args, **kwargs)
		else:
			return retVal
	return wrapper

def retStr(function, *args, **kwargs):
	return lambda *args, **kwargs: str(function(*args, **kwargs))

def retSciNot(function, *args, **kwargs):
	return lambda *args, **kwargs: '{:e}'.format(function(*args, **kwargs))

def retAbsVal(function, *args, **kwargs):
	return lambda *args, **kwargs: abs(function(*args, **kwargs))

def toLow(function, *args, **kwargs):
	return lambda *args, **kwargs: function(*args, **kwargs).lower()

def decorators(*decs):
	def deco(f):
		for dec in reversed(decs):
			f = dec(f)
		return f
	return deco

